This is a proof of the correctness of the transitive closure defined
in file TCSym.lagda.

Author :: Andreas Abel
Created:: 2005-07-27

\begin{code}
-- # import TCSym


trans : (A->A->Prop) -> Prop
trans R = (x,y,z:A) -> x`R`y ==> y`R`z ==> x`R`z

(+) : Nat -> Nat -> Nat
axPlus : (x,y:Nat) -> 
             zero + x == x
          /\ (succ y) + x == succ (y + x)
          /\ x + y == y + x
         
R:A->A->Prop
 
lem1 : (x,y:A) -> (n:Nat) -> x `R` y ==> (tc n R) x y
lem1 x y = indNat
               (fol-plugin (axTc R))
               (\n ih -> fol-plugin (axTc R,ih))

lem2 : (x,y:A) -> (m,n:Nat) -> (tc m R) x y ==> (tc (n+m) R) x y
lem2 x y m = indNat
               (fol-plugin (axPlus,axTc R,lem1))
               (\n ih -> fol-plugin (axPlus,axTc R,ih))

axO : (R,R' : A->A->Prop) -> (x,z:A) -> 
         o R R' x z <=> Exists (\y -> x `R` y /\ y `R'` z)

lem3 : (n,m:Nat) -> (x,y,z:A) -> (tc n R) x y ==> (tc m R) y z ==> (tc (succ (n+m)) R) x z
lem3 n m = fol-plugin (axPlus,axTc R,axO (tc (n+m) R) (tc (n+m) R),lem2)

tcTrans : trans (TC R)
tcTrans = fol-plugin (lem3)

\end{code}

This was a positive experience in semi-automated theorem proving.  It will be even better when there is a substantial set of libraries around and when the translation to FOL is more liberal (switching forall and implies, forall under conjunction, framework arrow = implies).