
module TypeChecker.Monad.Datatypes where

import Control.Monad.State

import Syntax.Internal
import Syntax.Values
import TypeChecker.Monad
import TypeChecker.Errors
import TypeChecker.Monad.Errors
import Utils.Monads
import Utils.Map as Map

getDatatypes :: TC Datatypes
getDatatypes = tcDatatypes <$> get

lookupDatatype :: Name -> TC [(Name,DefValue)]
lookupDatatype x =
    do	mcs <- Map.lookup x <$> getDatatypes
	case mcs of
	    Just cs -> return cs
	    Nothing -> failure $ becauseNotADatatype (vDef x $ error "lookupDatatype")

addDatatype :: Name -> [(Name,DefValue)] -> TC ()
addDatatype x cs =
    modify $ \s -> s { tcDatatypes = insert x cs (tcDatatypes s) }

delDatatype :: Name -> TC ()
delDatatype x =
    modify $ \s -> s { tcDatatypes = delete x (tcDatatypes s) }

setDatatypes :: Datatypes -> TC ()
setDatatypes ds =
    modify $ \s -> s { tcDatatypes = ds }

