-- # import Property

-- some logical axioms

infix 14 *
infix 10 +
-- infix 6 ==

Ex : (A:Set) -> (A->Prop) -> Prop
witness : (A:Set) -> (P:A->Prop) -> (x:A) -> P x -> Ex A P
elimEx : (A:Set) -> (P:A->Prop) -> Ex A P -> (C:Prop) -> ((x:A)->P x ->C) -> C

-- natural numbers

-- general definitions

isRing : (X:Set) -> (X->X->X) -> (X->X->X) -> (X->X) -> X -> X -> Prop

isRing R (+) (*) minus Zero One =
 (x:R) -> (y:R) -> (z:R) ->
     (   x + y == y + x
      /\ x + Zero == x
      /\ x + (minus x) == Zero
      /\ x + (y+z) == (x+y)+z
      /\ x * (y+z) == (x*y) + (x*z)
      /\ (y+z) * x  == (y*x) + (z*x)
      /\ x * One == x
      /\ One * x == x
      /\ x * (y*z) == (x*y)*z
     )

isBool : (X:Set) -> (X->X->X) -> (X->X->X) -> (X->X) -> X -> X -> Prop

isBool R (+) (*) minus Zero One =
     isRing R (+) (*) minus Zero One 
 /\ ((x:R) -> x*x == x)

-- the example

R : Set
(+) : R -> R -> R
(*) : R -> R -> R
minus : R -> R 
Zero : R
One : R

axR : isBool  R (+) (*) minus Zero One 

thm : (x:R) -> x + x == Zero
--thm x = fol-plugin(axR)

thm1 : (x:R) -> (y:R) -> x * y == y * x
thm1 x y = fol-plugin(axR,thm)

(<=) : R -> R -> Prop
(<=) x y = x * y == x

thm2 : (x:R) -> x <= x
thm2 x = fol-plugin(axR)

thm3 : (x:R) -> Zero <= x
thm3 x = fol-plugin(axR,thm,thm1)

thm4 : (x:R) -> x <= One
thm4 x = fol-plugin(axR,thm,thm1)

thm5 : (x:R) -> (y:R) -> (z:R) -> x <= y ==> y <= z ==> x <= z
thm5 x y z = fol-plugin(axR,thm,thm1)

{- needs more than 3s without hint, which is surprising

thm6 : (x:R) -> (y:R) -> ( x == y <=> (x <= y /\ y <= x))
thm6 x y = fol-plugin(axR,thm,thm1)

thm7 : (x:R) -> (y:R) -> (z:R) -> ( x <= y*z <=> (x <= y /\ x <= z))
thm7 x y z = fol-plugin(axR,thm,thm1)
-}

thm6 : (x:R) -> (y:R) -> ( x == y <=> (x <= y /\ y <= x))
thm6 x y = 
 let 
   rem1 : x == y ==> (x <= y /\ y <= x)
   rem1 = fol-plugin(axR)
   rem2 : (x<=y /\ y<=x) ==> x == y
   rem2 = fol-plugin(axR,thm1)
 in 
  fol-plugin(rem1,rem2)

thm7 : (x:R) -> (y:R) -> (z:R) -> ( x <= y*z <=> (x <= y /\ x <= z))
thm7 x y z = 
 let 
   rem1 : x <= y*z ==> (x <= y /\ x <= z)
   rem1 = fol-plugin(axR,thm1)
   rem2 : (x<=y /\ x<=z) ==> x <= y*z
   rem2 = fol-plugin(axR)
 in 
  fol-plugin(rem1,rem2)


or : R -> R -> R
or x y = (x + y) + x*y

-- even more difficult


thm8 : (x:R) -> (y:R) -> (z:R) -> ( (or y z) <= x <=> (y <= x /\ z <= x))
thm8 x y z = 
 let 
   rem1 : y <= or y z
   rem1 =  fol-plugin(axR,thm,thm1)
   rem2 : z <= or y z
   rem2 =  fol-plugin(axR,thm,thm1)
   rem3 : (y<=x /\ z<=x) ==> or y z <= x
   rem3 = fol-plugin(axR,thm,thm1)
 in
  fol-plugin(rem1,rem2,rem3,thm5)


thm9 : (x:R) -> (y:R) -> (z:R) -> x * (or y z) == or (x * y) (x * z)
--thm9 x y z = fol-plugin(axR,thm,thm1)

not : R -> R
not x = One + x

thm10 : (x:R) -> x + not x == One /\ x * (not x) == Zero
thm10 x = fol-plugin(axR,thm)

thm11 : (x:R) -> or x (not x) == One
thm11 x = fol-plugin(axR,thm10)

thm12 : (x:R) -> (y:R) -> x * y == Zero <=> or x y == x + y
thm12 x y = 
 let 
  rem1 : x * y == Zero ==> or x y == x + y
  rem1 = fol-plugin(axR,thm)
  rem2 : or x y == x + y ==> x * y == Zero 
  rem2 = fol-plugin(axR,thm)
 in
  fol-plugin(rem1,rem2)

thm13 : (x:R) -> (y:R) -> or x (x * y) == x



D : Set

W : D -> (D -> D -> R) -> D -> D -> R
W a S x y = or (S x y) ((S x a) * (S a y))

-- gandalf can't do this! Why is it in test/succeed?  / Ulf
{-
test : (a:D) -> (b:D) -> (S:D->D->R) -> 
        (x:D) -> (y:D) -> W b (W a S) x y == W a (W b S) x y
test a b S x y = fol-plugin(axR,thm9,thm13,thm1)
-}
